//PrcSam01
#include <iom32.h>
#include <inavr.h>
#include <iomacro.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

/*
#define RXEN 0x10
#define TXEN 0x8
#define RXCIE 0x80
#define UDRIEn 0x20
#define TXCIEn 0x40
#define FE 0x10
#define DOR 0x08
#define UPE 0x04
#define UDRE 0x20
*/
#define REC_COM_TIMEOUT 255//    RS232

// *********  **********
//   .   ,  
//    -   CommandCode
//  -       -    (CRS)
//  -2 ( 0   ),  - 15+2=17
//   ,    
//-      .        
//   0xff;
//     RecBuff

//  -   ,   1  -   (,   ),
// -     2

// RS232
unsigned char TxBuf[40];//     
volatile unsigned char InitRS_Flg=0,TransmitEndFlg=1, *pTrBuff,NumTrData=0;
volatile unsigned char RecBuff[20];//  RS232
//     ,    ,    
volatile unsigned char RecBufCnt=0,NumReceive=0,CRS,CRST;
volatile unsigned char RecTimeoutCnt=0;
volatile unsigned char *pRecBuf;//     
volatile unsigned char RSError=0,RsErrData[8];

#pragma vector = USART_RXC_vect
__interrupt void RXC_int()
{char RS_DATA;
 if(UCSRA & ((1<<FE) | (1<<DOR) | (1<<PE)))	// break
	{if(UCSRA & (1<<FE)) InitRS_Flg=1;//  - break
         RS_DATA = UDR;
        // UCSRA=0;
         RecBufCnt=0;
         NumReceive=0;
         RecTimeoutCnt=0;
         SetBeep();
         RSError=1;
          //-  Break  RS
	}
 else
	{RS_DATA = UDR;
         //if(InitRS_Flg>0)//  
         //   {if(RS_DATA==0xff) transmit_char(0xff);
         //    InitRS_Flg=0;
         //    goto ExRSInt;
         //   };

     if(RecBufCnt==0)//  .==   -2
           {if(StartCommandFlg!=0)//    
               {RecBufCnt=0;
                NumReceive=0;
                RecTimeoutCnt=0;
                SetBeep();
                RSError=2;
                //FlashLed();
                SetBeep();
                goto ExRSInt;
               };
            
            NumReceive=(RS_DATA & 0x0f)+2;
            CRS=RS_DATA;
            pRecBuf=(volatile unsigned char *)RecBuff;
            *pRecBuf=RS_DATA;
            pRecBuf++;
            RecBufCnt=1;
            RecTimeoutCnt = REC_COM_TIMEOUT;
            //FlashLed();
            //SetBeep();
           }
         else //   
           {*pRecBuf=RS_DATA;
            CRS += RS_DATA;
            pRecBuf++;
            RecBufCnt++;
            //SetBeep();
            if(RecBufCnt >= NumReceive)
             {if(CRS==0xff)
                {StartCommandFlg++;
                 //SetBeep();
                //FlashLed();
                }
              else // -  RS +Break
                {SetBeep();
                 RSError=3;
                  //FlashLed();
                };
              RecBufCnt=0;
              RecTimeoutCnt=0;
             };
           };
     };
ExRSInt:;
}

//   RS-232
#pragma vector = USART_UDRE_vect
__interrupt void TXBuff_int()
{if(NumTrData>0)  {UDR=*pTrBuff++;NumTrData--;}
 else UCSRB &= ~(1<<UDRIE);
};

#pragma vector = USART_TXC_vect
__interrupt void TXC_int()
{if(NumTrData==0)
	{UCSRB &= ~(1<<TXCIE);
	 TransmitEndFlg=1;
	};
};

void transmit_char(unsigned char data)
{while(!(UCSRA & (1<<UDRE)));
 UDR=data;
}

void TransmitBuff(unsigned char NumData, unsigned char *pBuff)
{TransmitEndFlg=0;
 NumTrData=NumData;
 pTrBuff=pBuff;
 UCSRB |= (1<<TXEN) | (1<<TXCIE) | (1<<UDRIE);
 return;
}

/*
//   RS-232
#pragma vector = USART1_UDRE_vect
__interrupt void TXBuff_int()
{if(NumTrData>0)  {UDR1=*pTrBuff++;NumTrData--;}
 else UCSR1B &= ~UDRIEn;
};

#pragma vector = USART1_TXC_vect
__interrupt void TXC_int()
{if(NumTrData==0)
	{UCSR1B &= ~TXCIEn;
	 TransmitEndFlg=1;
	};
};

void transmit_char(unsigned char data)
{while(!(UCSR1A & UDRE));
 UDR1=data;
}

void TransmitBuff(unsigned char NumData, unsigned char *pBuff)
{TransmitEndFlg=0;
 NumTrData=NumData;
 pTrBuff=pBuff;
 UCSR1B |= TXEN | TXCIEn | UDRIEn;
 return;
};

*/

void InitRS232()// ********* USART1 init
{//U2X (float speed)  MPCM(MultiProcCommMode)  
 UCSRA=0;
 //   (RXCIE),  (RXEN),  (TXEN)
 //    (TXCIE  UDRIE) 
 //  (RXB8  TXB8)  
 //UCZ2=0 (8)
 UCSRB = (1<<RXCIE) | (1<<RXEN) | (1<<TXEN);
 //UMSEL=0( ),    (UPM1=1),  (UPM0=0,even)
 //2  (UCBS=1),8   (UCSZ1..0=3  UCSZ2=0(UCSR1B)), UCPOL=0( CLK      )
 UCSRC = (1<<URSEL) | (2<<4/*UPM*/) | (1<<3/*UCBS*/) | (3<<1/*UCSZ1..0*/);//-    !!!
 //BaudRate=9600
 UBRRL=47;//9600
 UBRRH=0;
 RSError=0;
 RecBufCnt=0;
 pRecBuf=RecBuff;
 NumReceive=0;
 InitRS_Flg=0;
 RecTimeoutCnt=0;
 StartCommandFlg=0;

}
