//PrcSam01
#include <iom32.h>
#include <inavr.h>
#include <iomacro.h>
#include <ctype.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
// 
//#define DS18S20_MODE //     DS18S20
#define FAST_PWM_MODE //    (100 ) 

__flash const unsigned char  TabWin[128] = { 
0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf, //  
0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, //  
0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf, //  
0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed, 0xee, //  
0xef, 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, //  
0xa2, 0xf7, 0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, //   
0xfe, 0xff, 0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec, //  
0xb5, 0xee, 0xef, 0xf0, 0xf1, 0xf2, 0xfd, 0xff, //   
0x41, 0xa0, 0x42, 0xa1, 0xe0, 0x45, 0xa3, 0xa4, //  
0xa5, 0xa6, 0x4b, 0xa7, 0x4d, 0x48, 0x4f, 0xa8, //  
0x50, 0x43, 0x54, 0xa9, 0xaa, 0x58, 0xe1, 0xab, //  
0xac, 0xe2, 0xad, 0xae, 0x62, 0xaf, 0xb0, 0xb1, //  
0x61, 0xb2, 0xb3, 0xb4, 0xe3, 0x65, 0xb6, 0xb7, //  
0xb8, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0x6f, 0xbe, //  
0x70, 0x63, 0xbf, 0x79, 0xe4, 0x78, 0xe5, 0xc0, //  
0xc1, 0xe6, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7 //  
}; 

#define QUATZ_FREQ 8// 15// 

#define F_QUARTZ_FREQ 7.3728
//__delay_cycles(unsigned long int)
#define DelayUs(Delay) __delay_cycles((unsigned long int)(F_QUARTZ_FREQ*(float)Delay+1.0))

#define REF_AVCC 0x40
#define REF_2_56 0xc0

#define TIMER_PERIOD 3686//     F_QUARTZ_FREQ*500 = 0.5 msec
#define  TIMER1_CNT 2000  //     1
//#define TIMER_BIG_PERIOD 20//  ,   1 
#define BEEP_LENGTH 200

#define FIRST_ADC 0x01//   
#define ADC_NUM_CHAN 4
#define ADC_NUM_CYCLES 32

#ifndef DS_MAX_UNITS
#define DS_MAX_UNITS 4
#endif

#define DS_RESET_TIME0 108 //480 
#define DS_RESET_TIME1 14 //70 
#define DS_RESET_TIME2 92 //410 

#define CLAP_PWM_BYTE 0x10

#define KEY_STAT 2//     

#define AV_BITS_TBAK 0x01
#define AV_BITS_TDEF 0x02
#define AV_BITS_TCOL 0x04
#define AV_BITS_TRES 0x08
#define AV_BITS_LOG0 0x10
#define AV_BITS_LOG1 0x20
#define AV_BITS_LOG2 0x40
#define AV_BITS_LOG3 0x80

#define ENB_AVAR_STOP 0x10
#define ENB_DISCONNECT_STOP 0x20
#define AVAR_STOP_STATE 0x01

#define AV_BITS_ADC2 0x01
#define AV_BITS_ADC3 0x02

//    [0]-, [1]-;
__flash static unsigned char VersionInfo[2]={1,4};

//   SystemState
unsigned char SystemState=0,SysSigState,SysAvState;//  ,   
unsigned char LogInputsState=0;//   - PortA[4..7]

 //     
 __eeprom unsigned char ee_SysSigEnb=0,ee_SysAvarEnb=0,ee_AvBitInverse=0,ee_SystemState=0;
 unsigned char SysSigEnb=0,SysAvarEnb=0,AvBitInverse=0;
//      
 __eeprom unsigned char ee_MaxDisconnectTime=255;
 unsigned char MaxDisconnectTime=255,MaxDisconnectTimeCnt=255;


 unsigned char SysSigState_1,SysAvState_1;//  ,    - 1
 //      
 __eeprom unsigned char ee_SysSigEnb_1=0,ee_SysAvarEnb_1=0,ee_AvBitInverse_1=0;
 unsigned char SysSigEnb_1=0,SysAvarEnb_1=0,AvBitInverse_1=0;


 // 
 __eeprom unsigned char eeDisplayContrast=30,eeDisplayBright=50;//   
 __eeprom unsigned char ee_bWndShowEnable=0xff;//   
 unsigned char bWndShowEnable=0xff;//
 __eeprom unsigned char ee_UserDisplayParams[4]={0,2,9,10};
unsigned char UserDisplayParams[4];
//  , ,     EEPROM
__eeprom unsigned char ee_TBakNum=1,ee_TDefNum=2,ee_TColNum=0,ee_TResNum=3;
//  , ,    - 
unsigned char TBakNum=1,TDefNum=2,TColNum=0,TResNum=3;

//   , ,     EEPROM
__eeprom signed short int ee_iTBakMax=1760,ee_iTDefMax=1760,ee_iTColMax=1760,ee_iTResMax=1760;//110*C
//   , ,    - 
signed short int iTBakMax,iTDefMax,iTColMax,iTResMax;

//   2  3  EEPROM
__eeprom signed short int ee_iAdc2Max=300,ee_iAdc3Max=300;//110*C
//   2  3 - 
signed short int iAdc2Max,iAdc3Max;


//   , ,   
signed short int iTBak,iTDef,iTCol,iTRes;

__eeprom signed short int ee_iAdc2Shift=41,ee_iAdc3Shift=0;// 
signed short int iAdc2Shift=41,iAdc3Shift=0;//
__eeprom float ee_fAdc2Mult=0.081,ee_fAdc3Mult=1.0;// 
float fAdc2Mult=0.081,fAdc3Mult=1.0;//

//  *********       ********
//BakWorkMode=0-,1-,2-  (Adc2),
//3-  (TBak)    
 unsigned char BakWorkMode=0,bBak_InvPow=0;//   EEPROM
 __eeprom float ee_fBak_K_Prop=10.0,ee_fBak_K_Int=0.01,ee_fBak_K_Dif=0.1;// 
 float fBak_K_Prop=10.0,fBak_K_Int=0.005,fBak_K_Dif=1.0;//  
 //  
 float fBak_IntSum=0.0,fBak_OldVal=0.0;//   
 unsigned short int iBak_ParamVal=0;//  (,2   TBak)

//  *********     ********
//ResWorkMode=0-,1-,2- Adc3, TRes    
 unsigned char ResWorkMode=0,bRes_InvPow=0;//   EEPROM
 __eeprom float ee_fRes_K_Prop=10.0,ee_fRes_K_Int=0.01,ee_fRes_K_Dif=0.1;// 
 float fRes_K_Prop=10.0,fRes_K_Int=0.005,fRes_K_Dif=1.0;//  
 //  
 float fRes_IntSum=0.0,fRes_OldVal=0.0;//   
 unsigned short int iRes_ParamVal=0;//  (,3   TRes)

// - ,       EEPROM
 unsigned char ee_WrCnt=0;//        EEPROM
 //unsigned char ee_Wr1Cnt=0;//        EEPROM

//   ******    ******

#ifdef FAST_PWM_MODE
#define CLAP_100MC_CNT_VAL 2 //   100 
#else
#define CLAP_100MC_CNT_VAL 200 //   100 
#endif
 
// 
volatile unsigned short int ClapanTimCnt=CLAP_100MC_CNT_VAL;//  100   
volatile unsigned short int iClapanPeriodCnt=0;//C   
volatile unsigned short int ClapanPulseLenVal=50;//     
volatile unsigned char ClapPwmFlg=0;
signed short int NewClapanPulseLenVal;//   ClapanPulseLenVal
volatile unsigned char StartPulseCnt=0,StopPulseCnt=0;
// 
__eeprom unsigned char  ee_bPulseClapanMode=0;//   
unsigned char bPulseClapanMode=0;//
__eeprom unsigned short int ee_iClapanPeriod=100;//    100   - 10 
unsigned short int iClapanPeriod=100;//
__eeprom float ee_fClap_Kprop=1.0,ee_fClap_Kint=0.0,ee_fClap_Kdif=0.0;//  
float fClap_Kprop=1.0,fClap_Kint=0.0,fClap_Kdif=0.0;//
__eeprom unsigned char ee_ClapStSpPulseLen=255;//  /    
unsigned char ClapStSpPulseLen=255;//
unsigned char ClapWorkMode=0;//   . 0-  0, 1-  1, 2-,
                                      //3..5 . . ,   -;
unsigned char ClapOutInvers=0;//   
signed short int iClapanParamVal=0;//    -  ;
float fClap_IntSum=0.0,fClap_OldVal=0.0;//  

//  
volatile unsigned char Deb_Tmp0=0,Deb_Tmp1=0;

// ****     ********
volatile unsigned short int tim_cnt;//  
volatile unsigned char BeepCnt=0, FlashLedCnt=0;//   FlashLed

//  ,  
volatile unsigned char Tim_Flg=0,StartCommandFlg=0;

// DS18
volatile unsigned char DsResetState=0,ResetReadyFlg=0,DsResetResult=0;
signed short int DsData[DS_MAX_UNITS];
unsigned char DsNumUnits=0;

void FlashLed()//  
{FlashLedCnt=200;
 asm ("sbi 0x15,2");//PORTC=0x15 
};

void SetBeep()//  
{BeepCnt = BEEP_LENGTH;// beep
 TCCR1A |= 0x80; // 
}

//  
char DString[2][17];

#define BREZ_PWM_LEN 100
// PWM
unsigned char NumPWM=3;//   PWM
signed short int PwmPow[3];//  ( %, 0..100) 3  
volatile unsigned char Int1Flg=0,PwmCnt,PwmOutPinsState;//  ,  , PwmOutPinsState -  4  - On/Off  
volatile signed short int PwmErr[3],PwmStep[3];//   

unsigned char BrezStep()//     
{unsigned char i,res=0,shift=0x80;
 signed short int up;//  
 signed short int step,err;//  ;
 for(i=0;i<NumPWM;i++)
   {up=PwmPow[i];
    step=PwmStep[i];
    err=PwmErr[i];
  
    step++;//      .
    if(step >= BREZ_PWM_LEN)
      {//   
       step=0;
       err = (up<<1) - BREZ_PWM_LEN;
      };
    if(err >= 0)  // 
	  {err += (up-BREZ_PWM_LEN)<<1;
	   res |= shift;
	  }
    else err += up<<1;

    shift >>= 1;
    PwmStep[i]=step;
    PwmErr[i]=err;
   };

 return res;
};

void PwmSetOutPins(unsigned char PwmOutPinsState)//    4  ( 4 )
{unsigned char c;
 __disable_interrupt();// 
 c=PORTC;// 
 // ,    PWM   
 if(NumPWM==3) {c &= 0x1f; c |= (PwmOutPinsState & 0xe0 );}
 else {c &= 0x3f; c |= (PwmOutPinsState & 0xc0 );};
 PORTC=c;//  
 __enable_interrupt();// 
};

#include "RS232.c"

//     INT1
#pragma vector = INT1_vect
__interrupt void Int1_int() //   2 
{Int1Flg=1;
}

//   2 -  Reset  DS
#pragma vector = TIMER2_COMP_vect
__interrupt void Tim2_Comp_int() //   2 
{TCCR2 &=~0x07;//  
 if(!DsResetState) goto end_t2_handle;//   
 //  DsReset DsResetState=0->  
 switch(DsResetState)
     {case 1://  Reset -      DS_RESET_TIME0
              OCR2=DS_RESET_TIME1;
              asm ("cbi 0x11,7");//   
              DsResetState++;
              break;
      case 2: //  Reset -     DS_RESET_TIME1,     
              OCR2=DS_RESET_TIME1;
              DsResetResult=PIND&0x80;
              DsResetState++;
              break;
      case 3: //  Reset -     DS_RESET_TIME2
              OCR2=DS_RESET_TIME2;
              DsResetState=0;
              ResetReadyFlg=1;
              goto end_t2_handle;//   
     };
 TCNT2=0;//  
 SFIOR |= 1<<PSR2;
 TCCR2 |= 0x03;//  
end_t2_handle:; //   
}

//  
volatile unsigned char KeyCnt=0, KeyStat=0,OldKey=0,KeyFlg=0,OutKey=0;
void KeyDecode(unsigned short int AdcCode)
{unsigned char ButCode;
 if(KeyFlg) return;//  .   .
  //     
 if(AdcCode<255) {ButCode=7; goto end_code;};
 if(AdcCode<598) {ButCode=6; goto end_code;};
 if(AdcCode<725) {ButCode=5; goto end_code;};
 if(AdcCode<794) {ButCode=4; goto end_code;};
 if(AdcCode<836) {ButCode=3; goto end_code;};
 if(AdcCode<866) {ButCode=2; goto end_code;};
 if(AdcCode<951) {ButCode=1; goto end_code;};
 ButCode=0;//  
end_code:;

 if(OldKey==ButCode) KeyCnt++;//    -  
 else {KeyCnt=0;OldKey=ButCode;return;};//     -     
 if(KeyCnt<KEY_STAT) return; // .   
 //  KEY_STAT 
 if(OldKey==0)// 
   {KeyStat=0;
    KeyCnt=0;
    return;
   };
// 
 if(KeyStat!=0)//      .     
   {KeyCnt=0;  
    return;
   };
//   -    
 OutKey=OldKey;
 KeyFlg=1;
 KeyStat=1;
 KeyCnt=0;
};

//  ADC 
// .  ,  ,  
volatile unsigned short int AdcIntData[ADC_NUM_CHAN],AdcOutData[ADC_NUM_CHAN],Glob_AdcOutData[ADC_NUM_CHAN];
volatile unsigned char AdcMultiplex=0;// 
volatile unsigned char FirstAdcBits=1,AdcNumCyclesCnt;//     ,   
volatile unsigned char AdcCycleFlg=0,AdcOuFlg=0;//   ,    

#pragma vector = ADC_vect
__interrupt void ADC_int()
{unsigned char c0,c1;
 if(!AdcCycleFlg)//   
 {c0=ADCL;//  
  c1=ADCH;
  AdcIntData[AdcMultiplex] = (((unsigned short int)c1)<<8) +c0;//    
  AdcMultiplex=(AdcMultiplex+1)&0x03;//  
  ADMUX = REF_AVCC | AdcMultiplex;//  , REF=AVCC
  if(AdcMultiplex==0)  AdcCycleFlg=1;//    -    
                                     //     
  else asm("sbi 0x06,6");//   (ADCSRA= 0x06)
 };//End if(!AdcCycleFlg)       -   
};

//    
#pragma vector = TIMER1_OVF_vect
__interrupt void Tim1_Owf_int() //   2 
{tim_cnt--;
 if(tim_cnt==0)//  
  {tim_cnt=TIMER1_CNT;
   if(Tim_Flg!=0xff) Tim_Flg++;
   if(Tim_Flg>1)
     {Deb_Tmp0++;
      //SetBeep();
      goto end_Tim1_Owf_int;//     -    !!! 
     };
  };// End if(tim_cnt==0)//   
 
//     
 if(Int1Flg)
   {Int1Flg=0;
    PwmCnt++;
    if(PwmCnt & 0x2) //    
      {PwmCnt=0;
       PwmSetOutPins(BrezStep());
       //     
      };
   };
 
 if(RecTimeoutCnt>0)//       - 
     {RecTimeoutCnt--; //      
      if(RecTimeoutCnt==0)//    
        {//UCSR1A=0;
         RecBufCnt=0;
         NumReceive=0;
         RSError=4;
         SetBeep();
         FlashLed();
        };
    };

 if(FlashLedCnt>0)//   . 
  {FlashLedCnt--;
   if(FlashLedCnt==0)  asm ("cbi 0x15,2");//PORTC=0x15 
  };

 if(bPulseClapanMode)//     
    {if(StopPulseCnt)
        {StartPulseCnt=0; asm ("cbi 0x15,4");
         StopPulseCnt--;
         if(!StopPulseCnt) asm ("cbi 0x15,5");//   
        };
     if(StartPulseCnt)
        {StartPulseCnt--;
         if(!StartPulseCnt) asm ("cbi 0x15,4");//   
        };
    };
 
 if(ClapanTimCnt>0)//    .  
  {//unsigned char c;//,c1;
   ClapanTimCnt--;
   if(ClapanTimCnt==0) //100 
     {ClapanTimCnt=CLAP_100MC_CNT_VAL;//  
     
      if(iClapanPeriodCnt<iClapanPeriod-1)
           {iClapanPeriodCnt++;//    .   
            if(iClapanPeriodCnt>=ClapanPulseLenVal)//   
                 {if(ClapPwmFlg)//    -    
                     {if(!bPulseClapanMode)
                          {//  0 ( 1) 4  PORTC=0x15
                           if(!ClapOutInvers) asm ("cbi 0x15,4"); else asm ("sbi 0x15,4");
                          }
                      else
                          {asm ("sbi 0x15,5");//   
                           StopPulseCnt=ClapStSpPulseLen;
                          };
                      ClapPwmFlg=0;//  
                     };
                 };
           }
      else //   .    
           {iClapanPeriodCnt=0;
            ClapanPulseLenVal=NewClapanPulseLenVal;
            if(ClapanPulseLenVal>0) ClapPwmFlg=1;// !=0    
            else ClapPwmFlg=0;// =0 -   
            if(ClapPwmFlg)//    -    
              {if(!bPulseClapanMode)
                  {if(ClapOutInvers) asm ("cbi 0x15,4"); else asm ("sbi 0x15,4");}
               else
                  {if(!StopPulseCnt)//     -  
                      {asm ("sbi 0x15,4");//   
                       StartPulseCnt=ClapStSpPulseLen;
                      };
                  };
              }
            else
              {if(!bPulseClapanMode)
                  {if(!ClapOutInvers) asm ("cbi 0x15,4"); else asm ("sbi 0x15,4");}
               else
                  {asm ("sbi 0x15,5");//   
                   StopPulseCnt=ClapStSpPulseLen;
                  };
              }
           };// End  if(iClapanPeriodCnt<iClapanPeriod-1)
     };//End if(ClapanTimCnt==0)
  };//End if(ClapanTimCnt>0)

 //    .   
 if(BeepCnt)
   {BeepCnt--;
    if(!BeepCnt) TCCR1A &= 0x3f;// 
   };
 
 //   4-  
 if(AdcCycleFlg)//    
 {unsigned short i;
  //  - 1  
  KeyDecode(AdcIntData[1]);//  
  
  if(!AdcOuFlg)//    
    {if(FirstAdcBits)//    - ,   - 
      {FirstAdcBits=0;//   
       for(i=0;i<ADC_NUM_CHAN;i++) AdcOutData[i]=AdcIntData[i];// 
      }
     else for(i=0;i<ADC_NUM_CHAN;i++) AdcOutData[i]+=AdcIntData[i];// 
     
     if(AdcNumCyclesCnt>0)//  ADC_NUM_CYCLES 
       {AdcNumCyclesCnt--;//  
        if(AdcNumCyclesCnt==0)//    
         {AdcOuFlg=1;//    
          AdcNumCyclesCnt=ADC_NUM_CYCLES;//  
          FirstAdcBits=1;//    
         };
       };
     AdcCycleFlg=0;//    
     asm("sbi 0x06,6");//   (ADCSRA= 0x06)
    };// End if(!AdcOuFlg);       -   
 };//End if(AdcCycleFlg);      -   
 
end_Tim1_Owf_int:; 
};//End    

#include "LCD_proc.c"
#include "DS18.c"

//      
void PwmSetValue(unsigned char PwmNum, unsigned char PwmValue)
{char EI=SREG&0x80;
 if(PwmNum>=NumPWM) return;
 if(PwmValue>100) PwmValue=100;
 if(EI) __disable_interrupt();// 
 PwmPow[PwmNum]=(signed short int)PwmValue;
// BrezStart(PwmNum);
 PwmStep[PwmNum]=0;
 PwmErr[PwmNum] = (PwmPow[PwmNum]<<1) - BREZ_PWM_LEN;
 if(EI) __enable_interrupt();// 
};

//  Reset  DS.    2.   ,  
unsigned char DsTimReset()
{if(!ResetReadyFlg && !DsResetState)//Reset    - 
  {//while(ASSR&(1<<TCR2UB);
   //while(TCCR2 & 0x03);//  ,    .  .
   OCR2=DS_RESET_TIME0;
   TCNT2=0;//  
   asm ("cbi 0x12,7");//  0 7  PORTD
   asm ("sbi 0x11,7");//   
   SFIOR |= 1<<PSR2;
   TCCR2 |= 0x03;//  
   DsResetState=1;
  };
 while(!ResetReadyFlg);
 ResetReadyFlg=0;
 return DsResetResult;
};

//  DString[][]      
void RefreshLCD()
{char i;
 unsigned char c;
 LcdSetAdr(0);
 for(i=0;i<16;i++)
   {c=DString[0][i];   
    if(c>=0x80) { c-=0x80; c=TabWin[c];};
    LcdTransmitChar(c);
   };
 LcdSetAdr(0x40); 
 for(i=0;i<16;i++)
   {c=DString[1][i];   
    if(c>=0x80) { c-=0x80; c=TabWin[c];};
    LcdTransmitChar(c);
   };
};

// ***********      ************
//  .    bEnable_PBak  true
void InitBakPid()
{fBak_IntSum=fBak_OldVal=0.0;};
//     
float tmp_pb_delta,tmp_pb_prop,tmp_pb_diff;
unsigned char BakPidHandle()
{unsigned char c;
 float d,d1;
 signed short int  iBakPid_Delta;
  switch(BakWorkMode)
  {default:
   case 0://
         return 0;
   case 1:c=(unsigned char)iBak_ParamVal;//
         if(c>100) c=100;
         //PwmSetValue(1,c);
         return c;
   case 2:if(bBak_InvPow) iBakPid_Delta = (Glob_AdcOutData[2]>>5)-iBak_ParamVal;//2
         else iBakPid_Delta = iBak_ParamVal-(Glob_AdcOutData[2]>>5);
         break;
   case 3:if(bBak_InvPow) iBakPid_Delta = iTBak-iBak_ParamVal;//TRes
         else iBakPid_Delta = iBak_ParamVal-iTBak;
  };
 d=(float)iBakPid_Delta;
 tmp_pb_delta=d;//
 fBak_IntSum+=d*fBak_K_Int;
 if(fBak_IntSum>100.0) fBak_IntSum=100.0;
 if(fBak_IntSum<-100.0) fBak_IntSum=-100.0;
 d1=fBak_IntSum;
 tmp_pb_prop=d*fBak_K_Prop;//
 d1+=tmp_pb_prop;//
 tmp_pb_diff=(d-fBak_OldVal)*fBak_K_Dif;//
 d1+=tmp_pb_diff;//
 fBak_OldVal=d;

 if(d1 > 100.0) d1=100.0;
 if(d1 < 0.0) d1=0.0;
 return (unsigned char)d1;
}

// ***********      ************
//  .
void InitResPid()
{fRes_IntSum=fRes_OldVal=0.0;
// if(ResWorkMode==1) PwmSetValue(1,Res_PwmSet);//   
};
//   
float tmp_res_delta,tmp_res_prop,tmp_res_diff;
unsigned char ResPidHandle()
{unsigned char c;
 float d,d1;
 signed short int  iResPid_Delta;
 switch(ResWorkMode)
  {default:
   case 0://PwmSetValue(1,0);//
         return 0;
   case 1:c=(unsigned char)iRes_ParamVal;//
         if(c>100) c=100;
         //PwmSetValue(1,c);
         return c;
   case 2:if(bRes_InvPow) iResPid_Delta = (Glob_AdcOutData[3]>>5)-iRes_ParamVal;//3
         else iResPid_Delta = iRes_ParamVal-(Glob_AdcOutData[3]>>5);
         break;
   case 3:if(bRes_InvPow) iResPid_Delta = iTBak-iRes_ParamVal;//TRes
         else iResPid_Delta = iRes_ParamVal-iTBak;
  };
 d=(float)iResPid_Delta;
 tmp_res_delta=d;//
 fRes_IntSum+=d*fRes_K_Int;
 if(fRes_IntSum>100.0) fRes_IntSum=100.0;
 if(fRes_IntSum<-100.0) fRes_IntSum=-100.0;
 d1=fRes_IntSum;
 tmp_res_prop=d*fRes_K_Prop;//
 d1+=tmp_res_prop;//
 tmp_res_diff=(d-fRes_OldVal)*fRes_K_Dif;//
 d1+=tmp_res_diff;//
 fRes_OldVal=d;

 if(d1 > 100.0) d1=100.0;
 if(d1 < 0.0) d1=0.0;
 return (unsigned char)d1;
}

//   .  ClapanPulseLenVal
float tmp_pc_delta,tmp_pc_prop,tmp_pc_diff;
unsigned char tmp_pc_res;
unsigned short int ClapanPidHandle()
{float d,d1;
 signed short int  iClapPid_Delta;
 switch(ClapWorkMode)
 {case 0: tmp_pc_res=0; return 0;//  0
  case 1: tmp_pc_res=100; return iClapanPeriod;//  1
  case 2:tmp_pc_res= (unsigned char) iClapanParamVal;
         return (unsigned short int)(((unsigned long int)iClapanParamVal
                                * (unsigned long int)iClapanPeriod)/100);
  case 3: iClapPid_Delta=iClapanParamVal - iTDef; break;
  case 4: iClapPid_Delta=iClapanParamVal - iTCol; break;
  case 5: iClapPid_Delta=iClapanParamVal - iTCol + iTDef; break;
 };
 d=(float)iClapPid_Delta;
 tmp_pc_delta=d;//
 fClap_IntSum+=d*fClap_Kint;
 if(fClap_IntSum>100.0) fClap_IntSum=100.0;
 if(fClap_IntSum<-100.0) fClap_IntSum=-100.0;
 d1=fClap_IntSum;
 tmp_pc_prop=d*fClap_Kprop;//
 d1+=tmp_pc_prop;//
 tmp_pc_diff=(d-fClap_OldVal)*fClap_Kdif;//
 d1+=tmp_pc_diff;//
 fClap_OldVal=d;

 if(d1 > 100.0) d1=100.0;
 if(d1 < 0.0) d1=0.0;
 tmp_pc_res=(unsigned char) d1;
 return (unsigned short int)(((unsigned long int)d1 * (unsigned long int)iClapanPeriod)/100);
}
//       float
float GetPrintParam(NumParam)
{float f;
 switch(NumParam)
    {case 0:f=(float)Glob_AdcOutData[1]/32.0;break;//2
     case 1:f=(float)Glob_AdcOutData[2]/32.0;break;//3(*)
     case 2:f=(float)Glob_AdcOutData[3]/32.0;break;//4(*)
     case 3:f=((float)Glob_AdcOutData[2]-(float)(iAdc2Shift<<5))/32.0*fAdc2Mult;break;//
     case 4:f=(float)iTBak*0.0625;break;//
     case 5:f=(float)iTDef*0.0625;break;//
     case 6:f=(float)iTCol*0.0625;break;//
     case 7:f=(float)iTRes*0.0625;break;//
     case 8:f=(float)(iTCol-iTDef)*0.0625;break;//-
     case 9:f=(float)PwmPow[0];break;//_
     case 10:f=(float)PwmPow[1];break;//1()
     case 11:f=(float)PwmPow[2];break;//2()
     case 12:f=(float)tmp_pc_res;break;//_
     case 13:f=(float)(LogInputsState>>4);break;//   
     default:f=0.0;
    };
 return f; 
};


// ***************** MAIN ************************
void main( void )
{unsigned char i,TmpFlg=0,TmpKey=0,GblOutKey=0,ShowState=0,ShowCnt=0;//,PwmTestVal=0;
 unsigned char Err=0;// 
 unsigned short int ui;
 
 
//     
 PORTA=0x00;
 DDRA=0x00;//   -  

 PORTB=0x00;// 0x80 -    -  
 DDRB=0xff;//   -  LCD

 //PC[7..2]-7..4 -   , 3 - a, 2-LED, 1..0 - I2C
 PORTC=0;
 DDRC=0xff;

 //PD0,PD1 - RXD  TXD; //PD2- INT ; //PD3- INT-PwmInt;
 //PD4 -     //PD5 -  //PD6 - -  DS1821 //PD7-Dallas
 PORTD=0x00;
 DDRD=0xf2;

 // ADC init
 //   7.3728  1/64  CLK=115.2 .
//   - 7.5    
 ADCSRA=0x8e;//ADC enable,Start-,AutoTrig ,Int  , ,ADPS[2..0]=6 - -64
 SFIOR &=0x0f;//ADTS[2..0]=0 (   )
 AdcMultiplex=0;// 
 ADMUX=REF_AVCC | AdcMultiplex;//(Ref=AVCC),ADLAR=0,MUX[4..0]=0(  ADC, SingleEnded);

 // ********* Timer 0 init -   
 // =  /256=28.8(7)
 //   ,    
 TCCR0=0x48 //WGM1[3]=1 WGM0[6]=1 FastPwm;
      | 0x20  //COM01[5]=1  COM00[4]=0    OC clear on OCR0;
      | 0x01; //CS02..00[2..1]=1 =1;
//   EEPROM.   -       
  if((eeDisplayContrast==0)||(eeDisplayContrast>100)) eeDisplayContrast=30;   
  OCR0=(unsigned char)(((long)eeDisplayContrast*256L)/100L);//
// OCR0=80;//31%-  .
 //PwmPow[4]=31;

 // *****  1 (16 )-  PWM (     )
 TCCR1A=0x02  //WGM11_WGM10 = 2[1..0]
      | 0x80 //COM1A(1..0)[7..6]=2;
      | 0x20; //COM1B(1..0)[5..4]=2;
 TCCR1B=0x18  //WGM1(3:2)=[4..3]=3;
      | 0x01; // ClkDiv[2..0]=1
 OCR1A=TIMER_PERIOD/2;//    50%
 
 if((eeDisplayBright==0)||(eeDisplayBright>100)) eeDisplayBright=50;
 OCR1B=(unsigned int)(((long)eeDisplayBright*TIMER_PERIOD)/100L);//
// OCR1B=TIMER_PERIOD/2;//    50%
 ICR1=TIMER_PERIOD;//  -  2  (7)
 //  -  COM1A(1..0)[7..6]=2; TCCR1A |= 0x80;
 //  -  COM1A(1..0)[7..6]=0;TCCR1A &= 0x3f; 
 TCCR1A &= 0x3f;// 
 TIMSK |= 1<<TOIE1;//     -  ICR1
//  TIMSK = 0x14;
 //PwmPow[5]=50;

// ********* Timer 2 init -   DsReset
 TCCR2=0x40 //WGM1[3]=0 WGM0[6]=1 CTC mode;
      | 0x00  //COM01[5]=0  COM00[4]=0     ;
      | 0x00; //CS02..00[2..1]=3 =1/32; 1  = 4.34  -  - 
 OCR2=111;// 
 SFIOR |= 1<<PSR2;//  
 TIMSK |= 1<<OCIE2;//  
 ASSR=0;//     
//   TCCR2 &=~0x07 -  CLK.   
//   SFIOR |= 1<<PSR2;TCCR2 |= 0x03
//   - TCNT2
//   480  -> 111
//   70  ->16
//   410  -> 94  
   
//   INT1   
 MCUCR |= 0x08;
 GICR |= 1<<INT1;
 
 
 InitRS232();
 
 // *********** Variables init
  SysSigState=SysAvState=0;
  SystemState=ee_SystemState &0xf0;
  SysSigEnb=ee_SysSigEnb;
  SysAvarEnb=ee_SysAvarEnb;
  AvBitInverse=ee_AvBitInverse;
  //      
  MaxDisconnectTime=ee_MaxDisconnectTime;
  MaxDisconnectTimeCnt=MaxDisconnectTime;
  
  bWndShowEnable=ee_bWndShowEnable;
  for(i=0;i<4;i++) UserDisplayParams[i]=ee_UserDisplayParams[i];
  
  TBakNum=ee_TBakNum;  TDefNum=ee_TDefNum;  TColNum=ee_TColNum;  TResNum=ee_TResNum;
  iTBakMax=ee_iTBakMax;  iTDefMax=ee_iTDefMax;  iTColMax=ee_iTColMax;  iTResMax=ee_iTResMax;
  iAdc2Shift=ee_iAdc2Shift;  iAdc3Shift=ee_iAdc3Shift;
  fAdc2Mult=ee_fAdc2Mult;  fAdc3Mult=ee_fAdc3Mult;

  //  *********       ********
  //BakWorkMode=0-,1-(PB_PwmSet),2-  (iAdc2Set),
  //3-  (iTBakSet)
  BakWorkMode=0;//  
  bBak_InvPow=0;//  
  fBak_K_Prop=ee_fBak_K_Prop;   fBak_K_Int=ee_fBak_K_Int;   fBak_K_Dif=ee_fBak_K_Dif;//  
    //   
  fBak_IntSum=0.0,fBak_OldVal=0.0;//   
  iBak_ParamVal=0;

  ee_WrCnt=0;//     EEPROM
  
  //
 //    
 iClapanPeriod=ee_iClapanPeriod;
 bPulseClapanMode=ee_bPulseClapanMode;
 if(bPulseClapanMode) NumPWM=2; else NumPWM=3;
 fClap_Kprop=ee_fClap_Kprop;
 fClap_Kint=ee_fClap_Kint;
 fClap_Kdif=ee_fClap_Kdif;
 ClapStSpPulseLen=ee_ClapStSpPulseLen;
 //  
 ClapWorkMode=0;
 ClapOutInvers=0;
// ClapPwmParamVal=0;
 iClapanParamVal=0;
 ClapanTimCnt=CLAP_100MC_CNT_VAL;
 iClapanPeriodCnt=0;
 ClapanPulseLenVal=0;
 ClapPwmFlg=0;
 fClap_IntSum=fClap_OldVal=0.0;
 StartPulseCnt=0;
 StopPulseCnt=0;
 
 //   
 ResWorkMode=0;
 bRes_InvPow=0;
 // 
 fRes_K_Prop=ee_fRes_K_Prop;//  
 fRes_K_Int=ee_fRes_K_Int;
 fRes_K_Dif=ee_fRes_K_Dif;
 // 
 fRes_IntSum=0.0,fRes_OldVal=0.0;//  
 iRes_ParamVal=0;

//   2  3 - 
 iAdc2Max=ee_iAdc2Max;
 iAdc3Max=ee_iAdc3Max;
 //      
 SysSigState_1=SysAvState_1=0;//  ,    - 1
 SysSigEnb_1=ee_SysSigEnb_1;
 SysAvarEnb_1=ee_SysAvarEnb_1;
 AvBitInverse_1=ee_AvBitInverse_1;
 
 Tim_Flg=0;
 tim_cnt=TIMER1_CNT;
 StartCommandFlg=0;
 FlashLedCnt=0;

 AdcMultiplex=0;
 AdcCycleFlg=0;
 FirstAdcBits=1;
 AdcNumCyclesCnt=ADC_NUM_CYCLES;
 AdcCycleFlg=0;
 AdcOuFlg=0;

 KeyFlg=0;OutKey=0;GblOutKey=0;
 
 for(i=0;i<8;i++)  RsErrData[i]=0;
 
 Int1Flg=0;
 PwmOutPinsState=0;
 PwmCnt=0;
 for(i=0;i<3;i++) PwmSetValue(i, 0);
// PwmSetValue(1, 50);//,   
 PwmSetOutPins(PwmOutPinsState);// -   

 InitLCD();
 
 DsResetState=0;
 DsResetResult=0;
 ResetReadyFlg=0; 
 DsNumUnits=0;
 for(i=0;i<DS_MAX_UNITS;i++) DsData[i]=0;
 sprintf(DString[0],"!V=%03d.%03d",VersionInfo[0],VersionInfo[1]);
 sprintf(DString[1]," DS18...   ");
 RefreshLCD();
 DsNumUnits=Ds_Scan();
 sprintf(DString[1]," %1d DS18  ",DsNumUnits);
 RefreshLCD();
 
 __enable_interrupt();// 

  // 
 asm("sbi 0x06,6");//ADCSRA=0x06;   ADSC=6;
 
//  
//Main Loop
loop:
 //  
  if(KeyFlg)
  {GblOutKey=OutKey;
   KeyFlg=0;
   SetBeep();
   // -   
   //............
    if(!TmpFlg)//     
    {TmpFlg=1;
     TmpKey=GblOutKey;
    };
  };
 //      EEPROM. ,      
  if(ee_WrCnt)
   {switch(ee_WrCnt)
      {case 1:ee_SysSigEnb=SysSigEnb;break;
       case 2:ee_SysAvarEnb=SysAvarEnb;break;
       case 3:ee_AvBitInverse=AvBitInverse;break;
       case 4:ee_bWndShowEnable=bWndShowEnable;break;
       case 5:ee_TBakNum=TBakNum;
       case 6:ee_TDefNum=TDefNum;
       case 7:ee_TColNum=TColNum;
       case 8:ee_TResNum=TResNum;
       case 9:ee_iTBakMax=iTBakMax;
       case 10:ee_iTDefMax=iTDefMax;
       case 11:ee_iTColMax=iTColMax;
       case 12:ee_iTResMax=iTResMax;
       case 13:ee_iAdc2Shift=iAdc2Shift;
       case 14:ee_iAdc3Shift=iAdc3Shift;
       case 15:ee_fAdc2Mult=fAdc2Mult;
       case 16:ee_fAdc3Mult=fAdc3Mult;
       case 17:ee_fBak_K_Prop=fBak_K_Prop;
       case 18:ee_fBak_K_Int=fBak_K_Int;
       case 19:ee_fBak_K_Dif=fBak_K_Dif;
       case 20:ee_fRes_K_Prop=fRes_K_Prop;
       case 21:ee_fRes_K_Int=fRes_K_Int;
       case 22:ee_fRes_K_Dif=fRes_K_Dif;
       case 23:ee_bPulseClapanMode=bPulseClapanMode;
       case 24:ee_iClapanPeriod=iClapanPeriod;
       case 25:ee_ClapStSpPulseLen=ClapStSpPulseLen;
       case 26:ee_fClap_Kprop=fClap_Kprop;
       case 27:ee_fClap_Kint=fClap_Kint;
       case 28:ee_fClap_Kdif=fClap_Kdif;
       case 29:ee_UserDisplayParams[0]=UserDisplayParams[0];       
       case 30:ee_UserDisplayParams[1]=UserDisplayParams[1];       
       case 31:ee_UserDisplayParams[2]=UserDisplayParams[2];       
       case 32:ee_UserDisplayParams[3]=UserDisplayParams[3];       
       case 33:ee_SystemState=SystemState&0xf0;       
       case 34:ee_iAdc2Max=iAdc2Max;       
       case 35:ee_iAdc3Max=iAdc3Max;

       case 36:ee_SysSigEnb_1=SysSigEnb_1;
       case 37:ee_SysAvarEnb_1=SysAvarEnb_1;
       case 38:ee_AvBitInverse_1=AvBitInverse_1;
       case 39:ee_MaxDisconnectTime=MaxDisconnectTime;
       case 40:ee_SystemState=SystemState &0xf0;
 
      default:break;
      };
    ee_WrCnt--;
   };

  Deb_Tmp1=TCNT0;//
// **************   *******************  
  if(Tim_Flg!=0)//    ( 1 )
     {Tim_Flg--;
   
      if(AdcOuFlg)//     -  
        {for(i=0;i<ADC_NUM_CHAN;i++) Glob_AdcOutData[i]=AdcOutData[i];
         AdcOuFlg=0;
        };

      // DS18
      if(DsNumUnits)
        {for(i=0;i<DsNumUnits;i++)
          {DsTimReset(); DsData[i]=Ds_Rd_Data(i);};
         DsTimReset();
         Ds_Wr_Byte(DS_SCIP_ROM);
         Ds_Wr_Byte(DS_START_CONV);
        };
      iTDef=DsData[TDefNum];//   
      iTCol=DsData[TColNum];
      iTBak=DsData[TBakNum];
      iTRes=DsData[TResNum];
      
      //  
      //    - PortA[4..7]
      LogInputsState=PINA;
      LogInputsState &= 0xf0;//  
      if(iTDef>iTDefMax) LogInputsState |= AV_BITS_TDEF;
      if(iTBak>iTBakMax) LogInputsState |= AV_BITS_TBAK;
      if(iTCol>iTColMax) LogInputsState |= AV_BITS_TCOL;
      if(iTRes>iTResMax) LogInputsState |= AV_BITS_TRES;

      LogInputsState ^= AvBitInverse;//  
      SysSigState = LogInputsState & SysSigEnb;//      
      SysAvState  = LogInputsState & SysAvarEnb;//      

      //     2  3
      //      
      //SysSigState_1=SysAvState_1=0;//  ,    - 1
      //SysSigEnb_1=ee_SysSigEnb_1;
      //SysAvarEnb_1=ee_SysAvarEnb_1;
      //AvBitInverse_1=ee_AvBitInverse_1;
      
      SysSigState_1=SysAvState_1=0;
      if((Glob_AdcOutData[2]>>5) > iAdc2Max) SysSigState_1 |= AV_BITS_ADC2;
      if((Glob_AdcOutData[3]>>5) > iAdc3Max) SysSigState_1 |= AV_BITS_ADC3;
      SysSigState_1 ^= AvBitInverse_1;
      SysAvState_1 = SysSigState_1 & SysAvarEnb_1;
      
      //     
      if(MaxDisconnectTimeCnt) MaxDisconnectTimeCnt--;
      if(SystemState & ENB_DISCONNECT_STOP)
        {if(!MaxDisconnectTimeCnt) SystemState |= 0x02;//   - 
        }
      else SystemState &= ~0x02;//  -   -      !!!
        

      if(SysAvState || (SystemState & 0x0f) || SysAvState_1) FlashLed();// -  
      if(SysSigState || SysAvState || (SystemState & 0x0f) || SysAvState_1 || SysSigState_1)
            SetBeep();//      
      //      -     AVAR_STOP_STATE
      //  -  .      RS
      // -     
      if(SystemState & ENB_AVAR_STOP)
       {if((SysAvState || SysAvState_1)) SystemState |= AVAR_STOP_STATE;
       }
      else SystemState &= ~AVAR_STOP_STATE;
    
      //  
      //   - ,   -  
      if(!SysAvState  && !(SystemState & 0x0f) && !SysAvState_1)
          ui=ClapanPidHandle();//    
      else ui=0;
        __disable_interrupt();// 
      NewClapanPulseLenVal=ui;
      __enable_interrupt();// 
    
      //  
      //       Glob_AdcOutData[2],    -  iTBak
      if(!SysAvState  && !(SystemState & 0x0f) && !SysAvState_1) PwmSetValue(0,BakPidHandle());
      else PwmSetValue(0,0);
      
      //   
      //       Glob_AdcOutData[3],    -  iTRes
      if(SysAvState  || (SystemState & 0x0f) || SysAvState_1) PwmSetValue(1,0);
      else PwmSetValue(1,ResPidHandle());
      
      //   RS232   -    
      if(RSError)
         {memcpy((void *)RsErrData,(void *)RecBuff,8);
          sprintf(DString[0],"RER=%2d %3d %3d  ",RSError,RsErrData[0],RsErrData[1]);
          sprintf(DString[1],"%3d %3d %3d %3d ",RsErrData[2],RsErrData[3],RsErrData[4],RsErrData[5]);
          RSError=0;
          goto end_show_prepare;
         };

      //   (+)/DS18  5 
      //  -    DS18 -  5 
      ShowCnt++;
      if(ShowCnt>4)
        {if(ShowState==0)//  (+)
           {if(bWndShowEnable & 0x01)
              {float f;
               sprintf(DString[0],"A0=%4d A1=%4d ",Glob_AdcOutData[0]>>5,Glob_AdcOutData[1]>>5);
               f=((float)Glob_AdcOutData[2]-(float)(iAdc2Shift<<5))/32.0*fAdc2Mult;
               sprintf(&DString[1][0],"%6.1f",f);
               f=((float)Glob_AdcOutData[3]-(float)(iAdc3Shift<<5))/32.0*fAdc3Mult;
               sprintf(&DString[1][8],"PA%6.1f",f);
               
               if(TmpFlg)
                {TmpFlg=0;
                 //DString[0][15]=TmpKey+'0';
                };
              }
            else ShowState++;
           };
         
         
         if(ShowState==1) //   DS18
           {if((DsNumUnits)&& (bWndShowEnable & 0x02))
              {float f;
               f=(float)iTBak*0.0625;
               if(f<100.0) sprintf(&DString[0][0],":%6.2f",f); else sprintf(&DString[0][0],":%6.1f",f);
               f=(float)iTDef*0.0625;
               if(f<100.0) sprintf(&DString[0][8],":%6.2f",f); else sprintf(&DString[0][8],":%6.1f",f);
               f=(float)iTCol*0.0625;
               if(f<100.0) sprintf(&DString[1][0],":%6.2f",f); else sprintf(&DString[1][0],":%6.1f",f);
               f=(float)iTRes*0.0625;
               if(f<100.0) sprintf(&DString[1][8],":%6.2f",f); else sprintf(&DString[1][8],":%6.1f",f);
              }
            else ShowState++;   
           };

         if(ShowState==2) //   
           {if(bWndShowEnable & 0x04)
              {sprintf(DString[0],"  :%03d%% K:%03d%%",PwmPow[0],tmp_pc_res);
               if(NumPWM==3)
                  sprintf(DString[1],"M1:%03d%% M2:%03d%% ",PwmPow[1],PwmPow[2]);
               else sprintf(DString[1],"M1:%3d%% M2:- ",PwmPow[1]);
              }
            else ShowState++;   
           };
         if(ShowState==3) //     
           {if(bWndShowEnable & 0x08)
              {sprintf(DString[0],"=%4.1f =%5.1f",
                        ((float)Glob_AdcOutData[2]-(float)(iAdc2Shift<<5))/32.0*fAdc2Mult,
                        (float)iTBak*0.0625);
               sprintf(DString[1],"=%03d =%1d",PwmPow[0],BakWorkMode);
              }
            else ShowState++;   
           };

         if(ShowState==4) //    
           {if(bWndShowEnable & 0x10)
              {sprintf(DString[0],"%5.2f %6.2f",(float)iTDef*0.0625,(float)iTCol*0.0625);//
               sprintf(DString[1],"=%03d =%1d ",tmp_pc_res,ClapWorkMode);//
              }
            else ShowState++;   
           };

         if(ShowState==5) // 
           {if(bWndShowEnable & 0x20)
              {sprintf(DString[0],"A3:%4.0f :%5.2f",
                        ((float)Glob_AdcOutData[3]-(float)(iAdc3Shift<<5))/32.0*fAdc3Mult,
                        (float)iTRes*0.0625);
               sprintf(DString[1],"=%03d =%1d",PwmPow[1],ResWorkMode);
              }
            else ShowState++;   
           };

         if(ShowState==6) //  
           {if(bWndShowEnable & 0x40)
             {sprintf(DString[0],"S0=%2x h A0=%2x h ",SysSigState,SysAvState);
              sprintf(DString[1],"C1=%2x h SS=%2x h ",SysSigState_1<<4 | SysAvState_1, SystemState);
             }
            else ShowState++;   
           };

         if(ShowState==7) //  
           {if(bWndShowEnable & 0x80)
             {sprintf(DString[0],"%7.2f %7.2f ",GetPrintParam(UserDisplayParams[0]),
                      GetPrintParam(UserDisplayParams[1]));
              sprintf(DString[1],"%7.2f %7.2f ",GetPrintParam(UserDisplayParams[2]),
                      GetPrintParam(UserDisplayParams[3]));
             }
            else ShowState++;   
           };
         ShowState++;
end_show_prepare:;      
         RefreshLCD();
         ShowCnt=0;
        };//End if(ShowCnt>5)

    if(ShowState>7) ShowState=0;
   };//End if(Tim_Flg!=0)
// **************    *******************  

// **************    RS-232 *******************  
//   RS-232.   -          (   )
//CommandCode=(RecBuff[0]>>4) & 0x0f; NumBytes=(RecBuff[0] & 0x0f);    NumBytes+2
//    RecBuff[1].   - CRS,  
//     - 2  -  (  =0)  CRS  
  
//
 if(!(StartCommandFlg && TransmitEndFlg)) goto end_rs_command; //     -   
// if(StartCommandFlg > 1) SetBeep();//Error -   -  ,   
//FlashLed();
 Err=0;
 switch(((RecBuff[0]>>4) &0x0f))
	{case 0://=0 -    .  ,   -  RecBuff[1]
            switch(RecBuff[1])
            {case 0:TxBuf[0]=0x0+15;//  
                    TxBuf[1]=VersionInfo[0];//  - //0
                    TxBuf[2]=VersionInfo[1];//  - //1
                    TxBuf[3]=SysSigEnb;//  //2
                    TxBuf[4]=SysAvarEnb;//  //3
                    TxBuf[5]=AvBitInverse;//  //4
                    TxBuf[6]=BakWorkMode;//   //5
                    TxBuf[7]=bBak_InvPow;//  //6
                    TxBuf[8]=ClapWorkMode;//   //7
                    TxBuf[9]=ClapOutInvers;//  //8
                    TxBuf[10]=bPulseClapanMode;//   //9
                    memcpy(&TxBuf[11],(void *)&iClapanPeriod,sizeof(short int));//10..11
                    TxBuf[13]=ClapStSpPulseLen;//  / //12
                    TxBuf[14]=ResWorkMode;//    //13
                    TxBuf[15]=bRes_InvPow;//  //14
                    CRST=0;
                    for(i=0;i<=15;i++) CRST+=TxBuf[i];
                    TxBuf[15+1]=255-CRST;
                    TransmitBuff(15+2, TxBuf);
                    break;

             case 1:TxBuf[0]=0x0+11;//   1
                    TxBuf[1]=TBakNum;//  //15
                    TxBuf[2]=TDefNum;//  //16
                    TxBuf[3]=TColNum;//  //17
                    TxBuf[4]=TResNum;//  //18
                    TxBuf[5]=bWndShowEnable;//   //19
                    TxBuf[6]=eeDisplayContrast;// //20
                    TxBuf[7]=eeDisplayBright;// //21
                    TxBuf[8]=UserDisplayParams[0];//    0 /22
                    TxBuf[9]=UserDisplayParams[1];//    1 //23    
                    TxBuf[10]=UserDisplayParams[2];//    2 //24
                    TxBuf[11]=UserDisplayParams[3];//    3 //25
                    CRST=0;
                    for(i=0;i<=11;i++) CRST+=TxBuf[i];
                    TxBuf[11+1]=255-CRST;
                    TransmitBuff(11+2, TxBuf);
                    break;

             case 2:TxBuf[0]=0x0+8;//   2 -  
                    memcpy(&TxBuf[1],(void *)&iTBakMax,sizeof(short int));//26..27
                    memcpy(&TxBuf[3],(void *)&iTDefMax,sizeof(short int));//28..29
                    memcpy(&TxBuf[5],(void *)&iTColMax,sizeof(short int));//30..31
                    memcpy(&TxBuf[7],(void *)&iTResMax,sizeof(short int));//32..33
                    CRST=0;
                    for(i=0;i<=8;i++) CRST+=TxBuf[i];
                    TxBuf[8+1]=255-CRST;
                    TransmitBuff(8+2, TxBuf);
                    break;

             case 3:TxBuf[0]=0x0+12;//   3 -   2  3
                    memcpy(&TxBuf[1],(void *)&iAdc2Shift,sizeof(short int));//34..35
                    memcpy(&TxBuf[3],(void *)&iAdc3Shift,sizeof(short int));//36..37
                    memcpy(&TxBuf[5],(void *)&fAdc2Mult,sizeof(float));//38..41
                    memcpy(&TxBuf[9],(void *)&fAdc3Mult,sizeof(float));//42..45
                    CRST=0;
                    for(i=0;i<=12;i++) CRST+=TxBuf[i];
                    TxBuf[12+1]=255-CRST;
                    TransmitBuff(12+2, TxBuf);
                    break;

             case 4:TxBuf[0]=0x0+15;//   4 -  
                    TxBuf[1]=BakWorkMode;//46
                    memcpy(&TxBuf[2],(void *)&iBak_ParamVal,sizeof(short int));//47..48
                    memcpy(&TxBuf[4],(void *)&fBak_K_Prop,sizeof(float));//49..52
                    memcpy(&TxBuf[8],(void *)&fBak_K_Int,sizeof(float));//53..56
                    memcpy(&TxBuf[12],(void *)&fBak_K_Dif,sizeof(float));//57..60
                    CRST=0;
                    for(i=0;i<=15;i++) CRST+=TxBuf[i];
                    TxBuf[15+1]=255-CRST;
                    TransmitBuff(15+2, TxBuf);
                    break;

             case 5:TxBuf[0]=0x0+15;//   5 -  
                    TxBuf[1]=ResWorkMode;//61
                    memcpy(&TxBuf[2],(void *)&iRes_ParamVal,sizeof(short int));//62..63
                    memcpy(&TxBuf[4],(void *)&fRes_K_Prop,sizeof(float));//64..67
                    memcpy(&TxBuf[8],(void *)&fRes_K_Int,sizeof(float));//68..71
                    memcpy(&TxBuf[12],(void *)&fRes_K_Dif,sizeof(float));//72..75
                    CRST=0;
                    for(i=0;i<=15;i++) CRST+=TxBuf[i];
                    TxBuf[15+1]=255-CRST;
                    TransmitBuff(15+2, TxBuf);
                    break;
                    
             case 6:TxBuf[0]=0x0+15;//   6 -  
                    TxBuf[1]=ClapWorkMode;//76
                    memcpy(&TxBuf[2],(void *)&iClapanParamVal,sizeof(short int));//77..78
                    memcpy(&TxBuf[4],(void *)&fClap_Kprop,sizeof(float));//79..82
                    memcpy(&TxBuf[8],(void *)&fClap_Kint,sizeof(float));//83..86
                    memcpy(&TxBuf[12],(void *)&fClap_Kdif,sizeof(float));//87..90
                    CRST=0;
                    for(i=0;i<=15;i++) CRST+=TxBuf[i];
                    TxBuf[15+1]=255-CRST;
                    TransmitBuff(15+2, TxBuf);
                    break;
                     
             case 7:TxBuf[0]=0x0+9;//   7 -   
                    TxBuf[1]=SystemState;//  
                    TxBuf[2]=SysSigState;// 
                    TxBuf[3]=SysAvState;// 
                    TxBuf[4]=DsNumUnits;// 
                    TxBuf[5]=LogInputsState;//     .  
                    TxBuf[6]=PwmPow[0];// 
                    TxBuf[7]=tmp_pc_res;// 
                    TxBuf[8]=PwmPow[1];//   1
                    TxBuf[9]=PwmPow[2];//   2
                    CRST=0;
                    for(i=0;i<=9;i++) CRST+=TxBuf[i];
                    TxBuf[9+1]=255-CRST;
                    TransmitBuff(9+2, TxBuf);
                    break;
             case 8:TxBuf[0]=0x0+14;//   8 -   
                    memcpy(&TxBuf[1],DsData,sizeof(short int)*4);// 4-  - 8
                    memcpy(&TxBuf[9],(void *)&Glob_AdcOutData[1],sizeof(short int)*3);//  1,2,3 - 6 
                    CRST=0;
                    for(i=0;i<=14;i++) CRST+=TxBuf[i];
                    TxBuf[14+1]=255-CRST;
                    TransmitBuff(14+2, TxBuf);
                    break;
             case 9:TxBuf[0]=0x0+12;//   9 - .   - 
                    memcpy(&TxBuf[1],(void *)&fBak_IntSum,sizeof(float));
                    memcpy(&TxBuf[5],(void *)&fRes_IntSum,sizeof(float));
                    memcpy(&TxBuf[9],(void *)&fClap_IntSum,sizeof(float));
                    CRST=0;
                    for(i=0;i<=12;i++) CRST+=TxBuf[i];
                    TxBuf[12+1]=255-CRST;
                    TransmitBuff(12+2, TxBuf);
                    break;
             case 10:TxBuf[0]=0x0+10;//New    10 -      2  3  
                    memcpy(&TxBuf[1],(void *)&iAdc2Max,sizeof(short));//91..92
                    memcpy(&TxBuf[3],(void *)&iAdc3Max,sizeof(short));//93..94
                    TxBuf[5]=SysSigState_1;//95
                    TxBuf[6]=SysAvState_1;//96
                    TxBuf[7]=SysSigEnb_1;//97
                    TxBuf[8]=SysAvarEnb_1;//98
                    TxBuf[9]=AvBitInverse_1;//99
                    TxBuf[10]=MaxDisconnectTime;//100
                    CRST=0;
                    for(i=0;i<=10;i++) CRST+=TxBuf[i];
                    TxBuf[10+1]=255-CRST;
                    TransmitBuff(10+2, TxBuf);
                    break;

             default:Err++;
            };
            if(Err) RSError=5;
            break;
     case 1://  
            if(bPulseClapanMode) NumPWM=2; else NumPWM=3;
            if(RecBuff[1] & 0x01) InitBakPid();
            if(RecBuff[1] & 0x04) InitResPid();
            if(RecBuff[1] & 0x02) fClap_IntSum=fClap_OldVal=0.0;
            TxBuf[0]=0x10;
            TxBuf[1]=255-0x10;
            TransmitBuff(2, TxBuf);
			break;
     case 2://    EEPROM
            ee_WrCnt=40;
            TxBuf[0]=0x20;
            TxBuf[1]=255-0x20;
            TransmitBuff(2, TxBuf);
			break;
     case 3://  SystemState. RecBuff[1] - , RecBuff[2] - 
            SystemState &= ~RecBuff[2];
            SystemState |= RecBuff[1]&RecBuff[2];
            TxBuf[0]=0x30;
            TxBuf[1]=255-0x30;
            TransmitBuff(2, TxBuf);
			break;
     case 4:RSError=6;
			break;
            
     case 5:RSError=7;
			break;

     case 8:// ,     . 3   - , , 
            eeDisplayBright=RecBuff[1];
            eeDisplayContrast=RecBuff[2];
            OCR1B=(unsigned int)(((long)RecBuff[1]*TIMER_PERIOD)/100L);//
            OCR0=(unsigned short)(((long)RecBuff[2]*256L)/100L);//
            bWndShowEnable=RecBuff[3];
            UserDisplayParams[0]=RecBuff[4];//    0 
            UserDisplayParams[1]=RecBuff[5];//    1 
            UserDisplayParams[2]=RecBuff[6];//    2 
            UserDisplayParams[3]=RecBuff[7];//    3 

            TxBuf[0]=0x80;//   =0 +    
 			TxBuf[1]=0xff-0x80;
 			TransmitBuff(2, TxBuf);
			break;
     case 9://   PwmPower(0..2).  - PWM,  - 
            if(RecBuff[1]>2) RecBuff[1]=2;
            if(RecBuff[2]>100) RecBuff[2]=100;
            PwmSetValue(RecBuff[1],RecBuff[2]);
            TxBuf[0]=0x90;//   =0 +    
 			TxBuf[1]=0xff-0x90;
 			TransmitBuff(2, TxBuf);
			break;
    case 10://  ,    +    -  11 
            SysSigEnb=TxBuf[1];//  
            SysAvarEnb=TxBuf[2];//  
            AvBitInverse=TxBuf[3];//  
            iTBakMax=*((short int *)&TxBuf[4]);
            iTDefMax=*((short int *)&TxBuf[6]);
            iTColMax=*((short int *)&TxBuf[8]);
            iTResMax=*((short int *)&TxBuf[10]);
            TxBuf[0]=0xa0;//   =0 +    
 			TxBuf[1]=0xff-0xa0;
 			TransmitBuff(2, TxBuf);
			 break;             
    case 11://    - 15 
            BakWorkMode=RecBuff[1];
            iBak_ParamVal=*((signed short int *)&RecBuff[2]);
            fBak_K_Prop=*((float *)&RecBuff[4]);
            fBak_K_Int=*((float *)&RecBuff[8]);
            fBak_K_Dif=*((float *)&RecBuff[12]);
            //InitBakPid();//  
            TxBuf[0]=0xb0;//   =0 +    
 			TxBuf[1]=0xff-0xb0;
 			TransmitBuff(2, TxBuf);
			 break;             
    case 12://    - 15 
            ClapWorkMode=RecBuff[1];
            iClapanParamVal=*((signed short int *)&RecBuff[2]);
            fClap_Kprop=*((float *)&RecBuff[4]);
            fClap_Kint=*((float *)&RecBuff[8]);
            fClap_Kdif=*((float *)&RecBuff[12]);
            //fClap_IntSum=fClap_OldVal=0.0;//  
            TxBuf[0]=0xc0;//   =0 +    
 			TxBuf[1]=0xff-0xc0;
 			TransmitBuff(2, TxBuf);
			 break;             
    case 13://    - 15 
            ResWorkMode=RecBuff[1];
            iRes_ParamVal=*((signed short int *)&RecBuff[2]);
            fRes_K_Prop=*((float *)&RecBuff[4]);
            fRes_K_Int=*((float *)&RecBuff[8]);
            fRes_K_Dif=*((float *)&RecBuff[12]);
            //InitResPid();//   
            TxBuf[0]=0xd0;//   =0 +    
 			TxBuf[1]=0xff-0xd0;
 			TransmitBuff(2, TxBuf);
			 break;             
    case 14:RSError=8;
			 break;             

    case 15:// .  RecBuff[1] - ,  ,     -  
            switch (RecBuff[1])
                {case 0:SysSigEnb=RecBuff[2];//0
                        SysAvarEnb=RecBuff[3];//1
                        AvBitInverse=RecBuff[4];//2
                        bWndShowEnable=RecBuff[5];//3
                        TBakNum=RecBuff[6];//4
                        TDefNum=RecBuff[7];//5
                        TColNum=RecBuff[8];//6
                        TResNum=RecBuff[9];//7
                        UserDisplayParams[0]=RecBuff[10];//8
                        UserDisplayParams[1]=RecBuff[11];//9
                        UserDisplayParams[2]=RecBuff[12];//10
                        UserDisplayParams[3]=RecBuff[13];//11
                        break;
                 case 1:iTBakMax=*((signed short int *)&RecBuff[2]);//12..13
                        iTDefMax=*((signed short int *)&RecBuff[4]);//14..15
                        iTColMax=*((signed short int *)&RecBuff[6]);//16..17
                        iTResMax=*((signed short int *)&RecBuff[8]);//18..19
                 case 2:iAdc2Shift=*((signed short int *)&RecBuff[2]);//20..21
                        iAdc3Shift=*((signed short int *)&RecBuff[4]);//22..23
                        fAdc2Mult=*((float *)&RecBuff[6]);//24..27
                        fAdc3Mult=*((float *)&RecBuff[10]);//28..31
                 case 3:BakWorkMode=RecBuff[2];//32
                        ResWorkMode=RecBuff[3];//33
                        ClapWorkMode=RecBuff[4];//34
                        bBak_InvPow=RecBuff[5];//35
                        bRes_InvPow=RecBuff[6];//36
                        ClapOutInvers=RecBuff[7];//37
                        bPulseClapanMode=RecBuff[8];//38
                        iClapanPeriod=*((signed short int *)&RecBuff[9]);//39..40
                        ClapStSpPulseLen=RecBuff[11];//41
                        if(bPulseClapanMode) NumPWM=2; else NumPWM=3;//   
                 case 4:iBak_ParamVal=*((signed short int *)&RecBuff[2]);//42..43
                        fBak_K_Prop=*((float *)&RecBuff[4]);//44..47
                        fBak_K_Int=*((float *)&RecBuff[8]);//48..51
                        fBak_K_Dif=*((float *)&RecBuff[12]);//52..55
                        //InitBakPid();//  
                 case 5:iRes_ParamVal=*((signed short int *)&RecBuff[2]);//56..57
                        fRes_K_Prop=*((float *)&RecBuff[4]);//58..61
                        fRes_K_Int=*((float *)&RecBuff[8]);//62..65
                        fRes_K_Dif=*((float *)&RecBuff[12]);//66..69
                        //InitResPid();//   
                 case 6:iClapanParamVal=*((signed short int *)&RecBuff[2]);//70..71
                        fClap_Kprop=*((float *)&RecBuff[4]);//72..75
                        fClap_Kint=*((float *)&RecBuff[8]);//76..79
                        fClap_Kdif=*((float *)&RecBuff[12]);//80..83
                        //fClap_IntSum=fClap_OldVal=0.0;//  
                        break;
                 case 7:iAdc2Max=*((signed short int *)&RecBuff[2]);//84..85 - NEW    2  3
                        iAdc3Max=*((signed short int *)&RecBuff[4]);//86..87
                        SysSigEnb_1=RecBuff[6];//88
                        SysAvarEnb_1=RecBuff[7];//89
                        AvBitInverse_1=RecBuff[8];//90
                        MaxDisconnectTime=RecBuff[9];//91
                        break;
                default: RSError=9;
                };
            TxBuf[0]=0xf0;//   =0 +    
 			TxBuf[1]=0xff-0xf0;
 			TransmitBuff(2, TxBuf);
			break;

	 default:RSError=10;
 	};
 if(!RSError) MaxDisconnectTimeCnt=MaxDisconnectTime;

 //while(!TransmitEndFlg);
 StartCommandFlg=0;
 //SetBeep();
 //FlashLed();
end_rs_command:;
// **************     RS-232 *******************  
 goto loop;	
}

/*
// ******* I2C init
 TWBR=16;//  
 TWCR=(1<<TWINT) | (1<<TWEN)|(1<<TWSTO);// |(1<<TWIE) // .   ASK(TWEA)
 // TWI(TWEN)    
 TWSR=0;//TWPS=0(Prescaler=1)//  -   
 TWDR=0;//  -    
 TWAR=2;// 1,   0 - //   slave mode -  
 I2C_State=0;I2C_Flg=0,I2C_Err=0;I2C_DataNumCnt=0;//I2C ??????????
 

// I2C
unsigned char I2C_Command=0;//  I2C. 0-  , 1-, 2-
                            // 0x04- Stopa
unsigned char I2C_State=0;//  I2C
unsigned char I2C_Flg=0,I2C_Err=0;//      
unsigned char I2C_Address,I2C_NumData,*I2C_pData,I2C_DataNumCnt;
unsigned char I2C_DataBuf[17];// 

void big_delay(char NumCyc)//  TWI
{unsigned char i;
 if(NumCyc>254) NumCyc=254;
 for(i=0;i<NumCyc;i++) asm("nop");
}

//  I2C
void I2C_Handle(char StartCommandCode)//0-int,1-+,2- +,
{unsigned char i,Err=0;               //5-  ,6-  
 if(StartCommandCode==0x04)//   
  {switch(I2C_State)
     {case 0://     I2C
            	TWCR=1<<TWEN;//-  ,  
            	 break;
      case 1://  Start.  
			       	i=TWSR & 0xf8;
             	if ((i != 0x08) //START
                	&& (i != 0x10)//Repeated START
              	  )
             		{Err=i;goto ErrorEndCommand;};
			    I2C_State=2;// 
             	i= I2C_Address << 1;
             	if(!(I2C_Command & 0x01)) i |= 0x01;//
             	TWDR = i;
             	TWCR = (1<<TWINT) | (1<<TWEN)|(1<<TWIE);
             	break;
      case 2://  .         
             	if(I2C_Command & 0x01) i=0x18;//-MT_SLA+W_ACK
             	else i=0x40;//-MT_SLA+R_ACK
             	if ((TWSR & 0xF8) != i) {Err=TWSR & 0xF8;goto ErrorEndCommand;};
							
             	I2C_State=3;//   
             	if(I2C_Command & 0x01)//
              	{TWDR = *I2C_pData++;
				 TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE);
              	}
             	else //
              	{if(I2C_DataNumCnt==1) 	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE);
				 else TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE) | (1<<TWEA);
              	};
           	    I2C_DataNumCnt--;
             	break;
      case 3://       
				//  *********   
             	if(I2C_Command & 0x01) i=0x28;//-MT_DATA_ACK
             	else
					{if(I2C_DataNumCnt==0) i=0x58;//    -  ACK
					 else		i=0x50;//   -  ACK
					};
             	if ((TWSR & 0xF8) != i) {Err=3;goto ErrorEndCommand;};
				I2C_State=3;
   				//  **********     
				if(I2C_DataNumCnt==1)
					{if(I2C_Command & 0x01) //
						{TWDR = *I2C_pData++;
                 		 TWCR = (1<<TWINT) | (1<<TWEN)|(1<<TWIE);
						}
					 else //
						{*I2C_pData++=TWDR;
                 		 TWCR = (1<<TWINT) | (1<<TWEN) |(1<<TWIE); //  TWEA !!!
						};
				     I2C_DataNumCnt--;
					 break;
					};
				//  ***********   
				if(I2C_DataNumCnt==0)
              	  {//    
               	   if(!(I2C_Command & 0x02))//  
                		{I2C_Command=0;
                 		 I2C_State=0;
                 		 I2C_Flg=1;
                 		 I2C_Err=0;
                 		 //     
                 		 TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);// ,    0x02
                		}
               	    else //   Stop
                		{I2C_Command=0;
                 		 I2C_State=0;
                 		 I2C_Flg=1;
                 		 I2C_Err=0;
                 		 TWCR =1<<TWEN;//  
                		};
				   break;
              	  };
							// ********   
             	if(I2C_Command &0x01)//
                 		{TWDR = *I2C_pData++;
                 		 TWCR = (1<<TWINT) | (1<<TWEN)|(1<<TWIE);
                		}
                else //
                		{*I2C_pData++=TWDR;
                 		 TWCR = (1<<TWINT) | (1<<TWEN)| (1<<TWEA)|(1<<TWIE);
                		};
           		I2C_DataNumCnt--;
                break;
      case 4://       Stop-  
             	I2C_Command=0;
             	I2C_State=0;
             	I2C_Flg=1;
             	I2C_Err=0;
             	TWCR =1<<TWEN;// 
				SetBeep();
				big_delay(254);
				SetBeep();
             	break;
      default://- 
                Err=4;goto ErrorEndCommand;
   };//End case
  } //if(StartCommandCode==0x04)
 else // -    ( )
	{I2C_Command=StartCommandCode;// 0: Wr/nRD;  1: NoStop/Stop
     I2C_DataNumCnt=I2C_NumData;
 	 I2C_State=1;// Start
 	 I2C_Flg=0;
 	 TWCR=(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (1<<TWIE);//Start
	}; //End if(StartCommandCode==0x04)
 return;
ErrorEndCommand:
 //sprintf(G_str,"I2C_Hnd:Err %d %0x %0x",I2C_State,Err,i);
 //WrIndString(IndStrCnt++,0,strlen(G_str),G_str,1,255);			
 I2C_Command=0;
 I2C_State=0;
 TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO | (1<<TWIE));// 
 I2C_Flg=1;
 I2C_Err=Err;
};

#pragma vector = TWSI_vect
__interrupt void i2c_int()
{I2C_Handle(0x04);
};

unsigned char Conv2SymToUChar(unsigned char CursorPos)
{unsigned char c,c1;
 c = E_str[CursorPos] -48;
 c1 = E_str[CursorPos+1]-48;
 return c*10+c1;
};

void ConvUCharTo2Sym(unsigned char c, unsigned char CursorPos)
{unsigned char Sym,Sym1;
 Sym=c/10;
 Sym1=c - (Sym*10);
 E_str[CursorPos] = Sym+48;
 E_str[CursorPos+1] = Sym1+48;
};

unsigned int Conv4SymToUInt(unsigned char CursorPos)
{unsigned char c[4],i;
 for(i=0;i<4;i++)  c[i] = E_str[CursorPos+i] - 48;
 return ((unsigned int)c[0])*1000 +((unsigned int)c[1])*100 + ((unsigned int)c[2])*10 + (unsigned int)c[3];
};
void ConvUIntTo4Sym(unsigned int ic, unsigned char CursorPos)
{unsigned char i,c;
 unsigned int k=1000;
 for(i=0;i<4;i++)
 		{c=(unsigned char)(ic/k);
		 E_str[CursorPos+i]=c +48;
		 ic -= (unsigned int)c*k;
  	 k /= 10;
 		};
};

unsigned char BCDToCharConv(unsigned char Char,unsigned char Mask)
{unsigned char t0,t1,t2;
 t0=Char & 0x0f;
 t0=t0 & Mask;
 t1=Char & Mask;
 t1 = (t1>>4) &0x0f;
 t2=t0 + t1*10;
 return t2;
};

char CharToBCDConv(unsigned char ch)
{unsigned char c;
 c=ch/10;
 ch -= c*10;
 c <<= 4;
 c += ch;
 return c;
};

unsigned char WriteTimerDataInt(unsigned char *pData)
{unsigned int cnt=0;
 I2C_Address=0xd1// Ds1307 // PCF8563=0x51;
 I2C_pData=pData;//   
 I2C_NumData=17;//  
 I2C_Handle(1);// 17   ;   -  =0;
 while((!I2C_Flg) && (cnt++ < 10000));
 if(I2C_Err || (cnt>=10000))
 		{SetBeep();
  	     //sprintf(G_str,"WtWrABad E:%x C:%d",I2C_Err,cnt);
  	     //WrIndString(IndStrCnt++,0,strlen(G_str),G_str,1,255);
		 //while(!PushFlg);//   
 		 //PushFlg=0;
		 return 0;
 		};
 return 1;
};


unsigned char WrDataTime(unsigned char *Date,unsigned char *Time)//Date[day,mon,year] Time[hour,min,sec]
{	//   RealTimer.      I2C_DataBuf[0..16],
	//I2C_DataBuf[0]=0;  I2C_DataBuf[1..16]=  0..15 I2C_DataBuf[0]=0;//  ==0
	I2C_DataBuf[1]=0;//Control 0
	I2C_DataBuf[2]=0x11;//Int active
	I2C_DataBuf[3]=CharToBCDConv(Time[2]);//VL+sec(BCD)
	I2C_DataBuf[4]=CharToBCDConv(Time[1]);//minute(BCD)
	I2C_DataBuf[5]=CharToBCDConv(Time[0]);//hours(BCD)
	I2C_DataBuf[6]=CharToBCDConv(Date[0]);//days(BCD)
	I2C_DataBuf[7]=0;//weekdays 0..6
	I2C_DataBuf[8]=CharToBCDConv(Date[1]);//cen + month(BCD)
	I2C_DataBuf[9]=CharToBCDConv(Date[2]);//years(BCD)
	I2C_DataBuf[10]=0;//AE+Minute alarm
	I2C_DataBuf[11]=0;//AE+Hour alarm
	I2C_DataBuf[12]=0;//AE+Day alarm
	I2C_DataBuf[13]=0;//AE+WeekDay alarm
	I2C_DataBuf[14]=0x83;//EnbClk+FD
	I2C_DataBuf[15]=0x83;//TE+TD
	I2C_DataBuf[16]=0x55;//Timer value
	if(!WriteTimerDataInt(&I2C_DataBuf[0])) return 0;
	else return 1;
//	{sprintf(G_str,"RealTimeWriteError");
// 	 WrIndString(IndStrCnt++,0,strlen(G_str),G_str,1,255);	
//	 while(!PushFlg);//   
// 	 PushFlg=0;
};

{//   
 unsigned char Data[3],Time[3];
 Time[0]=Conv2SymToUChar(2);
 Time[1]=Conv2SymToUChar(5);
 Time[2]=Conv2SymToUChar(8);
 Data[0]=CurData.Date.Day;
 Data[1]=CurData.Date.Mon;
 Data[2]=CurData.Date.Year;
 if(!WrDataTime(Data,Time)) SetBeep();
};

unsigned char ReadTimerDataInt(unsigned char *pData)
{unsigned char i=0;
 unsigned int	cnt=0;
 I2C_Address=0x51;
 I2C_pData=&i;
 I2C_NumData=1;
 I2C_Handle(3);// 1   
 while((!I2C_Flg) && (cnt++ < 10000));
 if(I2C_Err || (cnt>=10000))
 		{SetBeep();
  	     //sprintf(G_str,"RtWrABad E:%x C:%d",I2C_Err,cnt);
  	     //WrIndString(IndStrCnt++,0,strlen(G_str),G_str,1,255);
		 //while(!PushFlg);//   
 		 //PushFlg=0;
		 //ClrScr();
		 return 0;
 		};
 I2C_pData=pData;
 I2C_NumData=16;
 I2C_Handle(0);// 16   
 cnt=0;
 while((!I2C_Flg) && (cnt++ < 10000));
 if(I2C_Err || (cnt>=10000))
 		{SetBeep();
  	 sprintf(G_str,"RtRdBad E:%x C:%d",I2C_Err,cnt);
  	 WrIndString(IndStrCnt++,0,strlen(G_str),G_str,1,255);
		 while(!PushFlg);//   
 		 PushFlg=0;
		 ClrScr();
		 return 0;
 		};
 return 1;
};

if(!ReadTimerDataInt(&I2C_DataBuf[0]))
		{//  
		};
	 //   .    I2C_DataBuf[0]  
	 CurData.Date.Day=BCDToCharConv(I2C_DataBuf[5],0x3f);
	 CurData.Date.Mon=BCDToCharConv(I2C_DataBuf[7],0x1f);
 	 CurData.Date.Year=BCDToCharConv(I2C_DataBuf[8],0xff);
 	 CurData.Time.Hour=BCDToCharConv(I2C_DataBuf[4],0x3f);
 	 CurData.Time.Min=BCDToCharConv(I2C_DataBuf[3],0x7f);
 	 CurData.Time.Sec=BCDToCharConv(I2C_DataBuf[2],0x7f);
*/

